import * as _udecode_plate_core from '@udecode/plate-core';

declare const BaseBasicMarksPlugin: _udecode_plate_core.SlatePlugin<_udecode_plate_core.PluginConfig<any, {}, {}, {}, {}>>;

/** Enables support for bold formatting */
declare const BaseBoldPlugin: _udecode_plate_core.SlatePlugin<_udecode_plate_core.PluginConfig<"bold", {}, {}, Record<"bold", {
    toggle: () => void;
}>, {}>>;

/** Enables support for code formatting */
declare const BaseCodePlugin: _udecode_plate_core.SlatePlugin<_udecode_plate_core.PluginConfig<"code", {}, {}, Record<"code", {
    toggle: () => void;
}>, {}>>;

/**
 * Enables support for highlights, useful when reviewing content or highlighting
 * it for future reference.
 */
declare const BaseHighlightPlugin: _udecode_plate_core.SlatePlugin<_udecode_plate_core.PluginConfig<"highlight", {}, {}, Record<"highlight", {
    toggle: () => void;
}>, {}>>;

/** Enables support for italic formatting. */
declare const BaseItalicPlugin: _udecode_plate_core.SlatePlugin<_udecode_plate_core.PluginConfig<"italic", {}, {}, Record<"italic", {
    toggle: () => void;
}>, {}>>;

/** Enables support for code formatting */
declare const BaseKbdPlugin: _udecode_plate_core.SlatePlugin<_udecode_plate_core.PluginConfig<"kbd", {}, {}, Record<"kbd", {
    toggle: () => void;
}>, {}>>;

/** Enables support for strikethrough formatting. */
declare const BaseStrikethroughPlugin: _udecode_plate_core.SlatePlugin<_udecode_plate_core.PluginConfig<"strikethrough", {}, {}, Record<"strikethrough", {
    toggle: () => void;
}>, {}>>;

/** Enables support for subscript formatting. */
declare const BaseSubscriptPlugin: _udecode_plate_core.SlatePlugin<_udecode_plate_core.PluginConfig<"subscript", {}, {}, Record<"subscript", {
    toggle: () => void;
}>, {}>>;

/** Enables support for superscript formatting. */
declare const BaseSuperscriptPlugin: _udecode_plate_core.SlatePlugin<_udecode_plate_core.PluginConfig<"superscript", {}, {}, Record<"superscript", {
    toggle: () => void;
}>, {}>>;

/** Enables support for underline formatting. */
declare const BaseUnderlinePlugin: _udecode_plate_core.SlatePlugin<_udecode_plate_core.PluginConfig<"underline", {}, {}, Record<"underline", {
    toggle: () => void;
}>, {}>>;

export { BaseBasicMarksPlugin, BaseBoldPlugin, BaseCodePlugin, BaseHighlightPlugin, BaseItalicPlugin, BaseKbdPlugin, BaseStrikethroughPlugin, BaseSubscriptPlugin, BaseSuperscriptPlugin, BaseUnderlinePlugin };
