import * as _udecode_plate_core_react from '@udecode/plate-core/react';
import * as _udecode_plate_core from '@udecode/plate-core';

/**
 * Enables support for basic marks:
 *
 * - Bold
 * - Code
 * - Italic
 * - Strikethrough
 * - Subscript
 * - Superscript
 * - Underline
 */
declare const BasicMarksPlugin: _udecode_plate_core_react.PlatePlugin<_udecode_plate_core.PluginConfig<any, {}, {}, {}, {}>>;

declare const BoldPlugin: _udecode_plate_core_react.PlatePlugin<_udecode_plate_core.PluginConfig<"bold", {}, {}, Record<"bold", {
    toggle: () => void;
}>, {}>>;

declare const CodePlugin: _udecode_plate_core_react.PlatePlugin<_udecode_plate_core.PluginConfig<"code", {}, {}, Record<"code", {
    toggle: () => void;
}>, {}>>;

declare const HighlightPlugin: _udecode_plate_core_react.PlatePlugin<_udecode_plate_core.PluginConfig<"highlight", {}, {}, Record<"highlight", {
    toggle: () => void;
}>, {}>>;

declare const ItalicPlugin: _udecode_plate_core_react.PlatePlugin<_udecode_plate_core.PluginConfig<"italic", {}, {}, Record<"italic", {
    toggle: () => void;
}>, {}>>;

/** Enables support for code formatting with React-specific features */
declare const KbdPlugin: _udecode_plate_core_react.PlatePlugin<_udecode_plate_core.PluginConfig<"kbd", {}, {}, Record<"kbd", {
    toggle: () => void;
}>, {}>>;

declare const StrikethroughPlugin: _udecode_plate_core_react.PlatePlugin<_udecode_plate_core.PluginConfig<"strikethrough", {}, {}, Record<"strikethrough", {
    toggle: () => void;
}>, {}>>;

declare const SubscriptPlugin: _udecode_plate_core_react.PlatePlugin<_udecode_plate_core.PluginConfig<"subscript", {}, {}, Record<"subscript", {
    toggle: () => void;
}>, {}>>;

declare const SuperscriptPlugin: _udecode_plate_core_react.PlatePlugin<_udecode_plate_core.PluginConfig<"superscript", {}, {}, Record<"superscript", {
    toggle: () => void;
}>, {}>>;

declare const UnderlinePlugin: _udecode_plate_core_react.PlatePlugin<_udecode_plate_core.PluginConfig<"underline", {}, {}, Record<"underline", {
    toggle: () => void;
}>, {}>>;

export { BasicMarksPlugin, BoldPlugin, CodePlugin, HighlightPlugin, ItalicPlugin, KbdPlugin, StrikethroughPlugin, SubscriptPlugin, SuperscriptPlugin, UnderlinePlugin };
